import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.Base64;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.PostMethod;


public class TestRest {
	
	public static String ip="http://labels-api.sanmarinomail.it";
	public static String API_USERNAME="username";
	public static String API_PASSWORD="password";
	public static String API_COMPANYID="ITIT000XXXX";
	public static HttpClient client=new HttpClient();
	
	
	public static void main(String[] args) {
		auth();
		label();
		DecodeZpl64();
	}
	
	public static void auth() {
		try {
		    		
			GetMethod gmethod=new GetMethod(ip+"/SanMarinoMailWeb2/api/user?USERNAME="+API_USERNAME+"&PASSWORD="+API_PASSWORD);
			      
		      int statusCode = client.executeMethod(gmethod);
		      byte[] responseBody = gmethod.getResponseBody();
		     
		      System.out.println("statusCode="+statusCode+" / "+HttpStatus.SC_OK);
		      System.out.println("responseBody="+(new String(responseBody)));
		     		   	 
		      RandomAccessFile label=new RandomAccessFile(new File("c:\\temp\\autTest.txt"),"rw");
		      label.write(responseBody);
		   	  label.close();
		 	  
		    } catch (HttpException e) {
		      System.err.println("Fatal protocol violation: " + e.getMessage());
		      e.printStackTrace();
		    } catch (IOException e) {
		      System.err.println("Fatal transport error: " + e.getMessage());
		      e.printStackTrace();
		    } finally {
		      // Release the connection.
		    
		    }  
/*
 * Risposta corretta:
 * statusCode=200
 * responseBody=<?xml version="1.0" encoding="UTF-8" ?><response><haserror>0</haserror><token>D58E8ddddgggg1C09FC77B54834DF5.serverTEST</token></response>
 * 
 * Risposta errata:
 * statusCode=401
 * responseBody=<?xml version="1.0" encoding="UTF-8" ?><response><haserror>1</haserror><errorCode>-1</errorCode><errorMessage>User Not Authorized</errorMessage></response>
 * */
	}
	
	public static void label() {
		try {
		    		
		      PostMethod pmethod=new PostMethod(ip+"/SanMarinoMailWeb2/api/label");
		      
		      pmethod.setParameter("ACTION","LABEL");

		      pmethod.setParameter("TCODE","0E43C5C5D8C8CEE260180313B9E2A8D2.server2");
		      pmethod.setParameter("SMM_PRODUCT_CODE","PRODUCT NAME");
		      pmethod.setParameter("SMM_CUST_CODE",API_COMPANYID);
		      pmethod.setParameter("DELIVERY_NAME","ICT");
		      pmethod.setParameter("PRE_ALLERT_DATE","27/08/2019");
		      pmethod.setParameter("DELIVERY_ADDR","SMM");
		      pmethod.setParameter("DELIVERY_CITY","WIEN");
		      pmethod.setParameter("DELIVERY_ZIP_CODE","1230");
			  pmethod.setParameter("WEIGHT","0.394");
			  pmethod.setParameter("CLIENT_SHIP_REF","TEST_XXX_001");
			  pmethod.setParameter("CLIENT_SHIP_REF_2","");
			  pmethod.setParameter("DEL_ISO_COUNTRY_CODE","AT");
			  pmethod.setParameter("DELIVERY_PHONE_NR","");
			  pmethod.setParameter("CONTENT","PARCEL");
			  pmethod.setParameter("PACKAGING_TYPE","01");
			  pmethod.setParameter("DELIVERY_INSTRUCTION","");
			  pmethod.setParameter("PARCEL","1");
			  pmethod.setParameter("OUTPUT_TYPE", "0");
			  pmethod.setParameter("LDV_PRINTING", "1");
			  pmethod.setParameter("DIMEN_PCS_LENGTH", "0");
			  pmethod.setParameter("DIMEN_PCS_WIDTH", "0");
			  pmethod.setParameter("DIMEN_PCS_HEIGHT", "0");
			
			      
		      int statusCode = client.executeMethod(pmethod);
		      byte[] responseBody = pmethod.getResponseBody();
		     
		      System.out.println("statusCode="+statusCode+" / "+HttpStatus.SC_OK);
		      System.out.println("responseBody="+(new String(responseBody)));
		     		   	 
		      RandomAccessFile label=new RandomAccessFile(new File("c:\\\\temp\\\\labelTest.txt"),"rw");
		      label.write(responseBody);
		   	  label.close();
		 	  
		    } catch (HttpException e) {
		      System.err.println("Fatal protocol violation: " + e.getMessage());
		      e.printStackTrace();
		    } catch (IOException e) {
		      System.err.println("Fatal transport error: " + e.getMessage());
		      e.printStackTrace();
		    } finally {
		      // Release the connection.
		    
		    }  
/*
 * Chiamata Corretta:
 * statusCode=200
responseBody=<?xml version="1.0" encoding="UTF-8" ?><response><haserror>0</haserror><label><clientShipRef>TEST_XXX_001</clientShipRef><clientShipRef2></clientShipRef2><usn>XXXXXXXXXXXX</usn><usnM>XXXXXXXXXXXX</usnM><data>BASE64LABEL</data><output>0</output><generationDate>Tue Aug 27 19:40:42 CEST 2019</generationDate></label></response>
 * 
 * Chiamata errata:
 * statusCode=200 
 * responseBody=<?xml version="1.0" encoding="UTF-8" ?><response><haserror>1</haserror><errorCode>1070</errorCode><errorMessage>Consistency Exception:Pre Allert Date is null or not valid. Format must be dd/MM/yyyy. Received:2019-08-27</errorMessage></response>
 * */
	}
	public static void Manifest() {
		String[] companyId=new String[]{API_COMPANYID}; 
		try {
		    int i=0;
		    while(i<companyId.length){
		
		      PostMethod pmethod=new PostMethod(ip+"/SanMarinoMailWeb2/api/manifest");
		      
		      pmethod.setParameter("ACTION","LABEL");

		      pmethod.setParameter("TCODE","0E43C5Cddddddd313B9E2A8D2.server2");
		      pmethod.setParameter("SMM_CUST_CODE",companyId[i]);
		      pmethod.setParameter("MANIFEST_ID","TEST_MANIFEST_001");
		      pmethod.setParameter("CLIENT_SHIP_REF_LIST","TEST_XXX_001,TEST_XXX_002");
		      pmethod.setParameter("MANIFEST_DATETIME","28/08/2019 18:00:00");
		    
			      
		      int statusCode = client.executeMethod(pmethod);
		      byte[] responseBody = pmethod.getResponseBody();
		     
		      System.out.println("statusCode="+statusCode+" / "+HttpStatus.SC_OK);
		      System.out.println("responseBody="+(new String(responseBody)));
		    
		     		   	 
		      RandomAccessFile label=new RandomAccessFile(new File("c:\\\\temp\\\\manifest_"+companyId[i]+".txt"),"rw");
		      label.write(responseBody);
		   	  label.close();
		   	  i++;
		    }
			
		    } catch (HttpException e) {
		      System.err.println("Fatal protocol violation: " + e.getMessage());
		      e.printStackTrace();
		    } catch (IOException e) {
		      System.err.println("Fatal transport error: " + e.getMessage());
		      e.printStackTrace();
		    } finally {
		      // Release the connection.
		    
		    }  

	}
	
	public static String DecodeZpl64() {
		String zplEncoded="XXXXXXXXXXXXXX";
		System.out.println("ZPL encoded="+zplEncoded);
		String decoded="";
		decoded = new String(Base64.getDecoder().decode(zplEncoded));
		System.out.println("ZPL="+decoded);
		return decoded;
	}
	
}
